<?php

namespace Teknisa\SM\Service;

use Teknisa\SM\Factory\SmPerfilDeAcessoDataSoucerFactory;

class SmPerfilDeAcessoDataSoucerService {
    
    protected $perfilDeAcessoFactory;
    
    public function __construct(SmPerfilDeAcessoDataSoucerFactory $perfilDeAcessoFactory) {
        $this->perfilDeAcessoFactory = $perfilDeAcessoFactory;
    }
    /**
     * A função "find" Busca os dados para a tela sem ou com filtro
     */
    public function find($filtros) {
        if(array_key_exists("NRPARCNEGOCIO", $filtros)){
            $filtros["NRPARCNEGOCIO"] = implode(",", $filtros["NRPARCNEGOCIO"]);
        }
        if(array_key_exists("NRPERFILACESSO", $filtros)){
            $filtros["NRPERFILACESSO"] = implode(",", $filtros["NRPERFILACESSO"]);
        }
        $perfisdeacesso = $this->perfilDeAcessoFactory->find($filtros);
        
        return $perfisdeacesso;
    }
    
    public function salvarOperacaoAcresOuDescont($nrseqdescperf, $nrperfilacesso, $nrorg, $cdservorca, $vrpercentual, $idtipo, $cdoperinclusao, $nrorginclusao, $idativo) {
        
         $params = array(
            "NRSEQDESCPERF" => $nrseqdescperf,
            "NRPERFILACESSO" => $nrperfilacesso,
            "IDTIPO" => $idtipo,
            "CDSERVORCA" => $cdservorca,
            "VRPERCENTUAL" => $vrpercentual,
            "CDOPERINCLUSAO" => $cdoperinclusao,
            "CDOPERULTATU" => null,
            "NRORGINCLUSAO" => $nrorginclusao,
            "NRORGULTATU" => null,
            "IDATIVO" => $idativo,
            "NRORG"          => $nrorg
        );
        
        $this->perfilDeAcessoFactory->salvarOperacaoAcresOuDescont($params);
    }
}
?>

