/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PAIS                                                     */
/* Tabela : PAIS                                                              */
/*                                                                            */
/* Criao:                                                                   */
/* 22/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/


CREATE OR REPLACE TRIGGER DTULTATU_PAIS
BEFORE INSERT OR UPDATE OR DELETE
ON PAIS FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPAIS := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPAIS,0) <> NVL(:NEW.CDPAIS,0)) OR
         (NVL(:OLD.NMPAIS,0) <> NVL(:NEW.NMPAIS,0)) OR
         (NVL(:OLD.CDPAISBACEN,0) <> NVL(:NEW.CDPAISBACEN,0)) THEN
         :NEW.DTULTATUPAIS := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PAIS', '', 'CDPAIS='||:OLD.CDPAIS||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PAIS MODIFY DTULTATUPAIS DEFAULT SYSDATE
/

